/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT2.dat, Mon Nov  7 23:54:41 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000954 (2388)
 *     Revision         0x01
 *     Checksum         0x73
 *     OEM ID           "NvORef"
 *     OEM Table ID     "NvOptTbl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20061109 (537268489)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "NvORef", "NvOptTbl", 0x00001000)
{
    External (GL00, IntObj)
    External (NVHA, MethodObj)    // 1 Arguments
    External (P8XH, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.PEG0, DeviceObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.LPCB.EC0_.BLTM)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, NotSerialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                Return (One)
            }
            Else
            {
                Return (\_SB.PCI0.PEG0.PEGP._DSM (Arg0, Arg1, Arg2, Arg3))
            }
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, SystemMemory, 0xF8008000, 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                    Offset (0x214), 
                    Offset (0x216), 
            LNKS,   4, 
                    Offset (0x224), 
                    Offset (0x225), 
            DQDA,   1, 
                    Offset (0xC28), 
            HCLQ,   1, 
                    Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
                    Offset (0xDFC), 
            PEPO,   3, 
                    Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
                    Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
                    Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
                    Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
                    Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
                    Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
                    Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
                    Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
                    Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
                    Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
                    Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
                    Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
                    Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
                    Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
                    Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
                    Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
                    Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (PCIS, SystemMemory, 0xF8100000, 0x0500)
        Field (PCIS, ByteAcc, Lock, Preserve)
        {
            SVID,   32, 
            NCMD,   8, 
            BDAT,   2000
        }

        Name (BKAL, Buffer (0xFA)
        {
            0x00
        })
        Method (NBAK, 0, NotSerialized)
        {
            Store (BDAT, BKAL)
        }

        Method (NRST, 0, NotSerialized)
        {
            Store (Zero, NCMD)
            Store (BKAL, BDAT)
            Store (0x06, NCMD)
        }

        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                ,   3, 
            DGVN,   1, 
                    Offset (0x0E), 
                ,   1, 
            DGPG,   1, 
                    Offset (0x38), 
                    Offset (0x3A), 
                ,   2, 
            DGRS,   1, 
                ,   1, 
                ,   1, 
                ,   1, 
            DGPW,   1, 
                    Offset (0x48), 
                ,   3, 
            DGSP,   1
        }

        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            Store (Zero, DGRS)
            Sleep (0x64)
            Store (Zero, DGPW)
            Sleep (0x64)
            While (LNotEqual (\_SB.PCI0.PEG0.PEGP.DGPG, One))
            {
                P8XH (Zero, 0x22)
                Sleep (One)
            }

            Store (One, DGRS)
            Sleep (0x64)
            If (LEqual (DGPG, One))
            {
                P8XH (Zero, 0x21)
            }

            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            NRST ()
        }

        Method (_OFF, 0, Serialized)
        {
            NBAK ()
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            Store (Zero, DGRS)
            Sleep (0x64)
            Store (One, DGPW)
            Sleep (0x64)
            If (LEqual (DGPG, Zero))
            {
                P8XH (Zero, 0x31)
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        OperationRegion (NVHM, SystemMemory, NVHA (0x00010400), Field (NVHM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x100), 
                        Offset (0x104), 
                RVBS,   32, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
    }

    Scope (\_SB.PCI0)
    {
        OperationRegion (RTCO, SystemIO, 0x72, 0x02)
        Field (RTCO, ByteAcc, NoLock, Preserve)
        {
            CIND,   8, 
            CDAT,   8
        }

        IndexField (CIND, CDAT, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x70), 
            OPST,   1
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_ROM, 2, NotSerialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (GOBT, 1, NotSerialized)
        {
            Name (OPVK, Buffer (0xE2)
            {
                /* 0000 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0008 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0010 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0018 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0020 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0028 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0030 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0038 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0040 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0048 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0050 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0058 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0060 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0068 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0070 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0078 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0080 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0088 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0090 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 0098 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00A0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00A8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00B0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00B8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00C0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00C8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00D0 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00D8 */    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
                /* 00E0 */    0x00, 0x00
            })
            CreateWordField (Arg0, 0x02, USRG)
            If (LEqual (USRG, 0x564B))
            {
                Return (OPVK)
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (OMPR, 0x02)
        Method (NVOP, 4, NotSerialized)
        {
            Name (_T_0, Zero)
            P8XH (Zero, 0x09)
            Store ("------- NV OPTIMUS DSM --------", Debug)
            If (LNotEqual (Arg1, 0x0100))
            {
                Return (0x80000001)
            }

            Store (ToInteger (Arg2), _T_0)
            If (LEqual (_T_0, Zero))
            {
                Store (Buffer (0x04)
                    {
                        0x00, 0x00, 0x00, 0x00
                    }, Local0)
                Divide (Zero, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x1A, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x10, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Divide (0x1B, 0x08, Local2, Local1)
                ShiftLeft (One, Local2, Local2)
                Or (DerefOf (Index (Local0, Local1)), Local2, Index (Local0, Local1
                    ))
                Return (Local0)
            }
            Else
            {
                If (LEqual (_T_0, 0x1A))
                {
                    CreateField (Arg3, 0x18, 0x02, OPCE)
                    CreateField (Arg3, Zero, One, FLCH)
                    If (ToInteger (FLCH))
                    {
                        Store (OPCE, OMPR)
                    }

                    Store (Buffer (0x04)
                        {
                            0x00, 0x00, 0x00, 0x00
                        }, Local0)
                    CreateField (Local0, Zero, One, OPEN)
                    CreateField (Local0, 0x03, 0x02, CGCS)
                    CreateField (Local0, 0x06, One, SHPC)
                    CreateField (Local0, 0x18, 0x03, DGPC)
                    CreateField (Local0, 0x1B, 0x02, HDAC)
                    Store (One, OPEN)
                    Store (One, SHPC)
                    Store (0x02, HDAC)
                    Store (One, DGPC)
                    If (\_SB.PCI0.PEG0.PEGP._STA ())
                    {
                        Store (0x03, CGCS)
                    }

                    Return (Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x1B))
                    {
                        Store (Arg3, Local0)
                        CreateField (Local0, 0x05, 0x02, OPOL)
                        CreateField (Local0, 0x07, One, OPSL)
                        Store (One, OPSL)
                        Store (\_SB.PCI0.OPST, OPOL)
                        Return (Local0)
                    }
                }
            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (DGOS, Zero)
        OperationRegion (PCNV, PCI_Config, 0x0488, 0x04)
        Field (PCNV, AnyAcc, NoLock, Preserve)
        {
                ,   25, 
            MLTF,   1
        }

        Method (_PS0, 0, NotSerialized)
        {
            If (DGOS)
            {
                \_SB.PCI0.PEG0.PEGP._ON ()
                If (And (LEqual (Zero, \_SB.PCI0.OPST), LEqual (Zero, \_SB.PCI0.LPCB.EC0.BLTM)))
                {
                    Store (GL00, Local4)
                    Or (Local4, 0x04, Local4)
                    Store (Local4, GL00)
                }
                Else
                {
                    Store (GL00, Local4)
                    And (Local4, 0xFB, Local4)
                    Store (Local4, GL00)
                }

                Store (Zero, DGOS)
                Store (Zero, MLTF)
            }
        }

        Method (_PS3, 0, NotSerialized)
        {
            If (LEqual (\_SB.PCI0.PEG0.PEGP.OMPR, 0x03))
            {
                \_SB.PCI0.PEG0.PEGP._OFF ()
                If (LEqual (Zero, \_SB.PCI0.OPST))
                {
                    Store (GL00, Local4)
                    Or (Local4, 0x04, Local4)
                    Store (Local4, GL00)
                }
                Else
                {
                    Store (GL00, Local4)
                    And (Local4, 0xFB, Local4)
                    Store (Local4, GL00)
                }

                Store (One, DGOS)
                Store (0x02, \_SB.PCI0.PEG0.PEGP.OMPR)
            }
        }

        Method (_STA, 0, NotSerialized)
        {
            Return (0x0F)
        }
    }

    Scope (\)
    {
        Method (CMPB, 2, NotSerialized)
        {
            Store (SizeOf (Arg0), Local1)
            If (LNotEqual (Local1, SizeOf (Arg1)))
            {
                Return (Zero)
            }

            Store (Zero, Local0)
            While (LLess (Local0, Local1))
            {
                If (LNotEqual (DerefOf (Index (Arg0, Local0)), DerefOf (Index (
                    Arg1, Local0))))
                {
                    Return (Zero)
                }

                Increment (Local0)
            }

            Return (One)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (_DSM, 4, NotSerialized)
        {
            Store ("----- DGPU _DSM --------", Debug)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xF8, 0xD8, 0x86, 0xA4, 0xDA, 0x0B, 0x1B, 0x47, 
                        /* 0008 */    0xA7, 0x2B, 0x60, 0x42, 0xA6, 0xB5, 0xBE, 0xE0
                    }))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000001)
        }
    }
}

